corosync-qdevice-net-certutil.sh 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394
  1. #!@BASHPATH@
  2. #
  3. # Copyright (c) 2015-2016 Red Hat, Inc.
  4. #
  5. # All rights reserved.
  6. #
  7. # Author: Jan Friesse (jfriesse@redhat.com)
  8. #
  9. # This software licensed under BSD license, the text of which follows:
  10. #
  11. # Redistribution and use in source and binary forms, with or without
  12. # modification, are permitted provided that the following conditions are met:
  13. #
  14. # - Redistributions of source code must retain the above copyright notice,
  15. # this list of conditions and the following disclaimer.
  16. # - Redistributions in binary form must reproduce the above copyright notice,
  17. # this list of conditions and the following disclaimer in the documentation
  18. # and/or other materials provided with the distribution.
  19. # - Neither the name of the Red Hat, Inc. nor the names of its
  20. # contributors may be used to endorse or promote products derived from this
  21. # software without specific prior written permission.
  22. #
  23. # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  24. # AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  25. # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  26. # ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  27. # LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  28. # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  29. # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  30. # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  31. # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  32. # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
  33. # THE POSSIBILITY OF SUCH DAMAGE.
  34. #
  35. BASE_DIR="@COROSYSCONFDIR@/qdevice/net"
  36. DB_DIR_QNETD="$BASE_DIR/qnetd/nssdb"
  37. DB_DIR_NODE="$BASE_DIR/node/nssdb"
  38. # Validity of certificate (months)
  39. CRT_VALIDITY=1200
  40. CA_NICKNAME="QNet CA"
  41. SERVER_NICKNAME="QNetd Cert"
  42. CLUSTER_NICKNAME="Cluster Cert"
  43. CA_SUBJECT="CN=QNet CA"
  44. SERVER_SUBJECT="CN=Qnetd Server"
  45. PWD_FILE_BASE="pwdfile.txt"
  46. NOISE_FILE_BASE="noise.txt"
  47. SERIAL_NO_FILE_BASE="serial.txt"
  48. CA_EXPORT_FILE="$DB_DIR_QNETD/qnetd-cacert.crt"
  49. CRQ_FILE_BASE="qnetd-node.crq"
  50. CRT_FILE_BASE="" # Generated from cluster name
  51. P12_FILE_BASE="qnetd-node.p12"
  52. QNETD_CERTUTIL_CMD="corosync-qnetd-certutil"
  53. usage() {
  54. echo "$0: [-i|-m|-M|-r|-s|-Q] [-c certificate] [-n cluster_name]"
  55. echo
  56. echo " -i Initialize node CA. Needs CA certificate from server"
  57. echo " -m Import cluster certificate on node (needs pk12 certificate)"
  58. echo " -r Generate cluster certificate request"
  59. echo " -M Import signed cluster certificate and export certificate with key to pk12 file"
  60. echo " -Q Quick start. Uses ssh/scp to initialze both qnetd and nodes."
  61. echo ""
  62. echo " -c certificate Ether CA, CRQ, CRT or pk12 certificate (operation dependant)"
  63. echo " -n cluster_name Name of cluster (for -r and -s operations)"
  64. echo ""
  65. echo "Typical usage:"
  66. echo "- Initialize database on QNetd server by running $QNETD_CERTUTIL_CMD -i"
  67. echo "- Copy exported QNetd CA certificate ($CA_EXPORT_FILE) to every node"
  68. echo "- On one of cluster node initialize database by running $0 -i -c `basename $CA_EXPORT_FILE`"
  69. echo "- Generate certificate request: $0 -r -n Cluster (Cluster name must match cluster_name key in the corosync.conf)"
  70. echo "- Copy exported CRQ to QNetd server"
  71. echo "- On QNetd server sign and export cluster certificate by running $QNETD_CERTUTIL_CMD -s -c `basename $CRQ_FILE_BASE` -n Cluster"
  72. echo "- Copy exported CRT to node where certificate request was created"
  73. echo "- Import certificate on node where certificate request was created by running $0 -M -c cluster-Cluster.crt"
  74. echo "- Copy output $P12_FILE_BASE to all other cluster nodes"
  75. echo "- On all other nodes in cluster:"
  76. echo " - Init database by running $0 -i -c `basename $CA_EXPORT_FILE`"
  77. echo " - Import cluster certificate and key: $0 -m -c `basename $P12_FILE_BASE`"
  78. echo ""
  79. echo "It is also possible to use Quick start (-Q). This needs properly configured ssh."
  80. echo " $0 -Q -n Cluster qnetd_server node1 node2 ... nodeN"
  81. exit 0
  82. }
  83. create_new_noise_file() {
  84. local noise_file="$1"
  85. if [ ! -e "$noise_file" ];then
  86. echo "Creating new noise file $noise_file"
  87. (ps -elf; date; w) | sha1sum | (read sha_sum rest; echo $sha_sum) > "$noise_file"
  88. chown root:root "$noise_file"
  89. chmod 400 "$noise_file"
  90. else
  91. echo "Using existing noise file $noise_file"
  92. fi
  93. }
  94. get_serial_no() {
  95. local serial_no
  96. if ! [ -f "$SERIAL_NO_FILE" ];then
  97. echo "100" > $SERIAL_NO_FILE
  98. fi
  99. serial_no=`cat $SERIAL_NO_FILE`
  100. serial_no=$((serial_no+1))
  101. echo "$serial_no" > $SERIAL_NO_FILE
  102. echo "$serial_no"
  103. }
  104. init_node_ca() {
  105. if [ -f "$DB_DIR/cert8.db" ];then
  106. echo "Certificate database already exists. Delete it to continue" >&2
  107. exit 1
  108. fi
  109. if ! [ -d "$DB_DIR" ];then
  110. echo "Creating $DB_DIR"
  111. mkdir -p "$DB_DIR"
  112. chown root:root "$DB_DIR"
  113. chmod 700 "$DB_DIR"
  114. fi
  115. echo "Creating new key and cert db"
  116. echo -n "" > "$PWD_FILE"
  117. certutil -N -d "$DB_DIR" -f "$PWD_FILE"
  118. chown root:root "$DB_DIR/key3.db" "$DB_DIR/cert8.db" "$DB_DIR/secmod.db"
  119. chmod 600 "$DB_DIR/key3.db" "$DB_DIR/cert8.db" "$DB_DIR/secmod.db"
  120. create_new_noise_file "$NOISE_FILE"
  121. echo "Importing CA"
  122. certutil -d "$DB_DIR" -A -t "CT,c,c" -n "$CA_NICKNAME" -f "$PWD_FILE" \
  123. -i "$CERTIFICATE_FILE"
  124. }
  125. gen_cluster_cert_req() {
  126. if ! [ -f "$DB_DIR/cert8.db" ];then
  127. echo "Certificate database doesn't exists. Use $0 -i to create it" >&2
  128. exit 1
  129. fi
  130. echo "Creating new certificate request"
  131. certutil -R -s "CN=$CLUSTER_NAME" -o "$CRQ_FILE" -d "$DB_DIR" -f "$PWD_FILE" -z "$NOISE_FILE"
  132. echo "Certificate request stored in $CRQ_FILE"
  133. }
  134. import_signed_cert() {
  135. if ! [ -f "$DB_DIR/cert8.db" ];then
  136. echo "Certificate database doesn't exists. Use $0 -i to create it" >&2
  137. exit 1
  138. fi
  139. echo "Importing signed cluster certificate"
  140. certutil -d "$DB_DIR" -A -t "u,u,u" -n "$CLUSTER_NICKNAME" -i "$CERTIFICATE_FILE"
  141. pk12util -d "$DB_DIR" -o "$P12_FILE" -W "" -n "$CLUSTER_NICKNAME"
  142. echo "Certificate stored in $P12_FILE"
  143. }
  144. import_pk12() {
  145. if ! [ -f "$DB_DIR/cert8.db" ];then
  146. echo "Certificate database doesn't exists. Use $0 -i to create it" >&2
  147. exit 1
  148. fi
  149. echo "Importing cluster certificate and key"
  150. pk12util -i "$CERTIFICATE_FILE" -d "$DB_DIR" -W ""
  151. }
  152. quick_start() {
  153. qnetd_addr="$1"
  154. master_node="$2"
  155. other_nodes="$3"
  156. # Sanity check
  157. for i in "$master_node" $other_nodes;do
  158. if ssh root@$i "[ -d \"$DB_DIR_QNETD\" ] || [ -d \"$DB_DIR_NODE\" ]";then
  159. echo "Node $i seems to be already initialized. Please delete $DB_DIR_QNETD and $DB_DIR_NODE" >&2
  160. exit 1
  161. fi
  162. if ! ssh "root@$i" "$0" > /dev/null;then
  163. echo "Node $i doesn't have $0 installed" >&2
  164. exit 1
  165. fi
  166. done
  167. # Initialize qnetd server (it's no problem if server is already initialized)
  168. ssh "root@$qnetd_addr" "$QNETD_CERTUTIL_CMD -i"
  169. # Copy CA cert to all nodes and initialize them
  170. for node in "$master_node" $other_nodes;do
  171. scp "root@$qnetd_addr:$CA_EXPORT_FILE" "$node:/tmp"
  172. ssh "root@$node" "$0 -i -c \"/tmp/`basename $CA_EXPORT_FILE`\" && rm /tmp/`basename $CA_EXPORT_FILE`"
  173. done
  174. # Generate cert request
  175. ssh "root@$master_node" "$0 -r -n \"$CLUSTER_NAME\""
  176. # Copy exported cert request to qnetd server
  177. scp "root@$master_node:$DB_DIR_NODE/$CRQ_FILE_BASE" "root@$qnetd_addr:/tmp"
  178. # Sign and export cluster certificate
  179. ssh "root@$qnetd_addr" "$QNETD_CERTUTIL_CMD -s -c \"/tmp/$CRQ_FILE_BASE\" -n \"$CLUSTER_NAME\""
  180. # Copy exported CRT to master node
  181. scp "root@$qnetd_addr:$DB_DIR_QNETD/cluster-$CLUSTER_NAME.crt" "root@$master_node:$DB_DIR_NODE"
  182. # Import certificate
  183. ssh "root@$master_node" "$0 -M -c \"$DB_DIR_NODE/cluster-$CLUSTER_NAME.crt\""
  184. }
  185. OPERATION=""
  186. CERTIFICATE_FILE=""
  187. CLUSTER_NAME=""
  188. while getopts ":hiMmQrc:n:" opt; do
  189. case $opt in
  190. r)
  191. OPERATION=gen_cluster_cert_req
  192. ;;
  193. i)
  194. OPERATION=init_node_ca
  195. ;;
  196. m)
  197. OPERATION=import_pk12
  198. ;;
  199. M)
  200. OPERATION=import_signed_cert
  201. ;;
  202. Q)
  203. OPERATION=quick_start
  204. ;;
  205. n)
  206. CLUSTER_NAME="$OPTARG"
  207. ;;
  208. h)
  209. usage
  210. ;;
  211. c)
  212. CERTIFICATE_FILE="$OPTARG"
  213. ;;
  214. \?)
  215. echo "Invalid option: -$OPTARG" >&2
  216. exit 1
  217. ;;
  218. :)
  219. echo "Option -$OPTARG requires an argument." >&2
  220. exit 1
  221. ;;
  222. esac
  223. done
  224. case "$OPERATION" in
  225. "init_qnetd_ca")
  226. DB_DIR="$DB_DIR_QNETD"
  227. ;;
  228. "init_node_ca")
  229. DB_DIR="$DB_DIR_NODE"
  230. ;;
  231. "gen_cluster_cert_req")
  232. DB_DIR="$DB_DIR_NODE"
  233. ;;
  234. "sign_cluster_cert")
  235. DB_DIR="$DB_DIR_QNETD"
  236. ;;
  237. "import_signed_cert")
  238. DB_DIR="$DB_DIR_NODE"
  239. ;;
  240. "import_pk12")
  241. DB_DIR="$DB_DIR_NODE"
  242. ;;
  243. "quick_start")
  244. DB_DIR=""
  245. ;;
  246. *)
  247. usage
  248. ;;
  249. esac
  250. PWD_FILE="$DB_DIR/$PWD_FILE_BASE"
  251. NOISE_FILE="$DB_DIR/$NOISE_FILE_BASE"
  252. SERIAL_NO_FILE="$DB_DIR/$SERIAL_NO_FILE_BASE"
  253. CRQ_FILE="$DB_DIR/$CRQ_FILE_BASE"
  254. CRT_FILE="$DB_DIR/cluster-$CLUSTER_NAME.crt"
  255. P12_FILE="$DB_DIR/$P12_FILE_BASE"
  256. case "$OPERATION" in
  257. "init_qnetd_ca")
  258. init_qnetd_ca
  259. ;;
  260. "init_node_ca")
  261. if ! [ -e "$CERTIFICATE_FILE" ];then
  262. echo "Can't open certificate file $CERTIFICATE_FILE" >&2
  263. exit 2
  264. fi
  265. init_node_ca
  266. ;;
  267. "gen_cluster_cert_req")
  268. if [ "$CLUSTER_NAME" == "" ];then
  269. echo "You have to specify cluster name" >&2
  270. exit 2
  271. fi
  272. gen_cluster_cert_req
  273. ;;
  274. "sign_cluster_cert")
  275. if ! [ -e "$CERTIFICATE_FILE" ];then
  276. echo "Can't open certificate file $CERTIFICATE_FILE" >&2
  277. exit 2
  278. fi
  279. if [ "$CLUSTER_NAME" == "" ];then
  280. echo "You have to specify cluster name" >&2
  281. exit 2
  282. fi
  283. sign_cluster_cert
  284. ;;
  285. "import_signed_cert")
  286. if ! [ -e "$CERTIFICATE_FILE" ];then
  287. echo "Can't open certificate file $CERTIFICATE_FILE" >&2
  288. exit 2
  289. fi
  290. import_signed_cert
  291. ;;
  292. "import_pk12")
  293. if ! [ -e "$CERTIFICATE_FILE" ];then
  294. echo "Can't open certificate file $CERTIFICATE_FILE" >&2
  295. exit 2
  296. fi
  297. import_pk12
  298. ;;
  299. "quick_start")
  300. shift $((OPTIND-1))
  301. qnetd_addr="$1"
  302. shift 1
  303. master_node="$1"
  304. shift 1
  305. other_nodes="$@"
  306. if [ "$CLUSTER_NAME" == "" ];then
  307. echo "You have to specify cluster name" >&2
  308. exit 2
  309. fi
  310. if [ "$qnetd_addr" == "" ];then
  311. echo "No QNetd server address provided." >&2
  312. exit 2
  313. fi
  314. if [ "$master_node" == "" ];then
  315. echo "No nodes provided." >&2
  316. exit 2
  317. fi
  318. quick_start "$qnetd_addr" "$master_node" "$other_nodes"
  319. ;;
  320. *)
  321. usage
  322. ;;
  323. esac